local font = "Interface\\AddOns\\ModifierState\\font.ttf"

local modifiers = CreateFrame("Frame", "RabbitModifiers", UIParent)
modifiers:SetPoint("CENTER", UIParent, "CENTER")
modifiers:SetWidth(320)
modifiers:SetHeight(100)
modifiers:SetFrameStrata("BACKGROUND")
modifiers:SetFrameLevel(1)
modifiers:EnableMouse(false)

local ctrl = modifiers:CreateFontString(nil, "OVERLAY")
ctrl:SetPoint("LEFT", modifiers)
ctrl:SetWidth(100)
ctrl:SetJustifyH("CENTER")
ctrl:SetFont(font, 42, "OUTLINE")
ctrl:SetShadowOffset(1, -1)
ctrl:SetTextColor(1, 0, 0, 1)
ctrl:SetText("Ctrl")
ctrl:Hide()

local alt = modifiers:CreateFontString(nil, "OVERLAY")
alt:SetPoint("CENTER", modifiers)
alt:SetWidth(100)
alt:SetJustifyH("CENTER")
alt:SetFont(font, 42, "OUTLINE")
alt:SetShadowOffset(1, -1)
alt:SetTextColor(1, 0, 0, 1)
alt:SetText("Alt")
alt:Hide()

local shift = modifiers:CreateFontString(nil, "OVERLAY")
shift:SetPoint("RIGHT", modifiers)
shift:SetWidth(100)
shift:SetJustifyH("CENTER")
shift:SetFont(font, 42, "OUTLINE")
shift:SetShadowOffset(1, -1)
shift:SetTextColor(1, 0, 0, 1)
shift:SetText("Shift")
shift:Hide()

-- We can't use MODIFIER_STATE_CHANGED, because it doesn't fire when you tab in/
-- out of WoW. So you might tab back in with Alt enabled.
modifiers:SetScript("OnUpdate", function()
	if IsShiftKeyDown() then shift:Show() else shift:Hide() end
	if IsAltKeyDown() then alt:Show() else alt:Hide() end
	if IsControlKeyDown() then ctrl:Show() else ctrl:Hide() end
end)

